﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace commands
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Button CommandButton = new Button();
            CommandButton.Command = ApplicationCommands.Open;
            CommandButton.Content = "Open (KeyBindings: Ctrl-R, Ctrl-0)";
            CommandButton.Height = 50;
            CommandButton.Width = 200;
            panel.Children.Add(CommandButton);

            CommandBinding OpenCmdBinding = new CommandBinding(
                ApplicationCommands.Open,
                    OpenCmdExecuted,
                    OpenCmdCanExecute);

            this.CommandBindings.Add(OpenCmdBinding);

            KeyGesture OpenKeyGesture = new KeyGesture(
                Key.O,
                ModifierKeys.Control);

            KeyBinding OpenCmdKeybinding = new KeyBinding(
                ApplicationCommands.Open,
                OpenKeyGesture);

            this.InputBindings.Add(OpenCmdKeybinding);

            CommandBinding HelpCmdBinding = new CommandBinding(
                ApplicationCommands.Help,
                    HelpCmdExecuted,
                    HelpCmdCanExecute);
            this.CommandBindings.Add(HelpCmdBinding);


        }

        void OpenCmdExecuted(object target, ExecutedRoutedEventArgs e)
        {
            String command, targetobj;
            command = ((RoutedCommand)e.Command).Name;
            targetobj = ((FrameworkElement)target).Name;
            MessageBox.Show("The " + command + " command has been invoked on target object " + targetobj);
        }
        void OpenCmdCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            if ( textBox1 != null && textBox1.Text != "")  e.CanExecute = true;
        }

        void HelpCmdExecuted(object target, ExecutedRoutedEventArgs e)
        {
            // seuraava avaa MyHelp.chm-tiedoston avustusohjelmassa jos chm-tiedosto löytyy
            // wpf:ssä ei ole kunnollista tukea chm-tiedostoille
            System.Windows.Forms.Help.ShowHelp(null, @"MyHelp.chm"); 
            // parasta ja yksinkertaisinta lienee käyttää normaaleja www-sivuja ja avata ne oletusselaimessa:
            System.Diagnostics.Process.Start("http://appro.mit.jyu.fi/gko/");

        }
        void HelpCmdCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
             e.CanExecute = true;
        }

    }
}
